SystemOrganization addCategory: #'Rest-Tests'!
SystemOrganization addCategory: #'Rest-Tests-Server'!
SystemOrganization addCategory: #'Rest-Tests-Fixtures'!
SystemOrganization addCategory: #'Rest-Tests-Client'!

RestHttpHandler subclass: #RestPerformHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestPerformHttpHandler methodsFor: 'request processing' stamp: 'SR 3/9/2009 15:49'!
process: anHTTPRequest
	"Takes first element in path as classname and sends message from third path element to that class."

	|pc class selector result|
	
	pc := anHTTPRequest uri identifierPath.
	class := pc second asSymbol.
	selector := pc third asSymbol.
	
	Smalltalk at: class ifPresent: [:c | 
		(c class allSelectors includes: selector) ifTrue: [result := c perform: selector]].

	^ HTTPResponse ok entity: result asString! !

Object subclass: #RestProxyRepositoryMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestProxyRepositoryMock methodsFor: 'private' stamp: 'mig 3/13/2009 16:20'!
deleteObject: anObject

	TestObject all removeFirst .! !

!RestProxyRepositoryMock methodsFor: 'instance creation' stamp: 'topa 3/3/2009 18:32'!
getObject: aString

	^ RestProxyObject new! !

Object subclass: #TestEntity
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

TestEntity class
	instanceVariableNames: 'lastId'!

TestEntity class
	instanceVariableNames: 'lastId'!

TestEntity subclass: #SecondLevelTestObject
	instanceVariableNames: 'testObject userName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!SecondLevelTestObject class methodsFor: 'as yet unclassified' stamp: 'mt 3/5/2009 17:21'!
newFrom: aDictionary

	^ self new userName: (aDictionary at: 'userName')! !

!SecondLevelTestObject class methodsFor: 'as yet unclassified' stamp: 'mt 3/5/2009 16:25'!
primitivePropertyNames

	^ #(id userName)! !

!SecondLevelTestObject class methodsFor: 'as yet unclassified' stamp: 'mig 3/13/2009 11:43'!
referencePropertyNames

	^ #(testObject)! !

!SecondLevelTestObject methodsFor: 'add/remove' stamp: 'topa 3/3/2009 22:12'!
delete

	self testObject removeSecondLevelTestObject: self.! !

!SecondLevelTestObject methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:08'!
testObject

	^ testObject! !

!SecondLevelTestObject methodsFor: 'accessing' stamp: 'mt 3/16/2009 17:17'!
testObject: aTestObject

	aTestObject ifNil: [testObject := nil. ^ self].
	testObject ifNotNil: [testObject secondLevelTestObjects remove: self. testObject := nil].
	aTestObject addSecondLevelTestObject: self.
	testObject := aTestObject.! !

!SecondLevelTestObject methodsFor: 'accessing' stamp: 'mt 3/5/2009 16:25'!
userName
	^ userName! !

!SecondLevelTestObject methodsFor: 'accessing' stamp: 'mt 3/5/2009 16:25'!
userName: aString 
	userName := aString! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'topa 3/3/2009 22:06'!
collectionPropertyNames

	^ #()! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:38'!
incrementId

	self pvtLastId: self pvtLastId + 1.
	^ self pvtLastId! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:37'!
initialize

	super initialize.
	self pvtLastId: 0.! !

!TestEntity class methodsFor: 'instance creation' stamp: 'mt 3/5/2009 16:27'!
prepare

	TestObject testObjects: OrderedCollection new.
	TestObject addTest: (TestObject new
		userName: 'Test Project';
		id: 1;
		addSecondLevelTestObject: (SecondLevelTestObject new userName: 'Micha');
		yourself).
	TestObject addTest: (TestObject new
		userName: 'Test2 Project2';
		id: 2).
	TestObject addTest: (TestObject new
		userName: 'Test3 Project3';
		id: 3).
		! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'topa 3/3/2009 22:07'!
primitivePropertyNames

	^ #()! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:37'!
pvtLastId

	^ lastId ifNil: [lastId := 0]! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'topa 3/3/2009 22:07'!
pvtLastId: anObject

	lastId := anObject.! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'mig 3/13/2009 11:43'!
referencePropertyNames

	^ #()! !

!TestEntity methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:05'!
id

	^ id! !

!TestEntity methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:05'!
id: anObject

	id := anObject.! !

!TestEntity methodsFor: 'printing' stamp: 'mig 3/13/2009 12:14'!
jsonWriteOn: aStream

	| result |
	result := Dictionary newFrom: (self class primitivePropertyNames collect: [ :aSymbol |
			aSymbol -> (self perform: aSymbol)]).
	result addAll: (Dictionary newFrom: (self class referencePropertyNames collect: [ :aSymbol | 
			'ref ', aSymbol -> ((self perform: aSymbol) ifNotNilDo: [:obj | obj restUri])])).
	result addAll: (Dictionary newFrom: (self class collectionPropertyNames collect: [ :aSymbol |
			'col ', aSymbol -> ((self perform: aSymbol) collect: [:each | each restUri])])).
	result jsonWriteOn: aStream.
	! !

!TestEntity methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:13'!
restUri

	^ (RestMockResourceHttpHandler uriMapping at: self class) value: self! !

TestEntity subclass: #TestObject
	instanceVariableNames: 'userName secondLevelTestObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

TestObject class
	instanceVariableNames: 'testObjects'!

TestObject class
	instanceVariableNames: 'testObjects'!

!TestObject class methodsFor: 'add-remove' stamp: 'topa 3/3/2009 22:08'!
addNewTest: aDictionary 

	^ self addTest: (self newFrom: aDictionary)! !

!TestObject class methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:09'!
addTest: aTestObject

	self testObjects add: aTestObject.
	^ aTestObject id: self incrementId! !

!TestObject class methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:09'!
all

	^ self testObjects! !

!TestObject class methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:09'!
collectionPropertyNames

	^ #(secondLevelTestObjects)! !

!TestObject class methodsFor: 'instance creation' stamp: 'mt 3/4/2009 14:17'!
newFrom: aDictionary

	^ self new
		userName: (aDictionary at: 'userName')! !

!TestObject class methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:00'!
primitivePropertyNames

	^ #(id userName)! !

!TestObject class methodsFor: 'add-remove' stamp: 'topa 3/3/2009 22:09'!
removeTestObject: aTestObject
	
	^ self testObjects remove: aTestObject! !

!TestObject class methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:09'!
testObjects

	^ testObjects! !

!TestObject class methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:09'!
testObjects: aCollection

	testObjects := aCollection.! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:27'!
addNewSecondLevelTestObject: aDictionary

	^ self addSecondLevelTestObject: (SecondLevelTestObject newFrom: aDictionary)! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'mt 3/16/2009 16:59'!
addSecondLevelTestObject: aSecondLevelTestObject 

	self secondLevelTestObjects add: aSecondLevelTestObject ifPresent: [^ aSecondLevelTestObject].
	aSecondLevelTestObject
		testObject: self;
		id: aSecondLevelTestObject class incrementId.
	^ aSecondLevelTestObject! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'topa 3/3/2009 22:17'!
delete

	self class removeTestObject: self.! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'topa 3/3/2009 22:11'!
initialize

	super initialize.
	self secondLevelTestObjects: OrderedCollection new.! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:29'!
removeSecondLevelTestObject: aSecondLevelTestObject

	self secondLevelTestObjects remove: aSecondLevelTestObject ifAbsent: [^ aSecondLevelTestObject].
	aSecondLevelTestObject testObject: nil.
	^ aSecondLevelTestObject! !

!TestObject methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:12'!
secondLevelTestObjects

	^ secondLevelTestObjects! !

!TestObject methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:12'!
secondLevelTestObjects: anObject

	secondLevelTestObjects := anObject.! !

!TestObject methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:13'!
userName
	^ userName! !

!TestObject methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:13'!
userName: anObject
	userName := anObject! !

RestResourceHttpHandler subclass: #RestMockResourceHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestMockResourceHttpHandler class methodsFor: 'as yet unclassified' stamp: 'topa 3/5/2009 11:57'!
rootResources

	^ Dictionary newFrom:	{'tests' -> TestObject}! !

!RestMockResourceHttpHandler class methodsFor: 'as yet unclassified' stamp: 'mt 3/5/2009 16:12'!
uriMapping

	^ Dictionary newFrom:{
		TestObject -> [:test| '/tests/{1}' format: {test id}].
		SecondLevelTestObject -> [:test | '/tests/{1}/secondLevelTestObjects/{2}' format: {test testObject id. test id}]}! !

RestResourceHttpHandler subclass: #RestMockResourceHttpHandlerAuth
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestMockResourceHttpHandlerAuth class methodsFor: 'as yet unclassified' stamp: 'topa 3/3/2009 21:50'!
rootResources

	^ Dictionary newFrom:	{'tests' -> TestObject}! !

!RestMockResourceHttpHandlerAuth class methodsFor: 'as yet unclassified' stamp: 'mfp 3/6/2009 17:06'!
uriMapping

	^ Dictionary newFrom:{
		TestObject -> [:test| '/tests/{1}' format: {test id}].
		SecondLevelTestObject -> [:test | '/tests/{1}/secondLevelTestObjects/{2}' format: {test testObject id. test id}]}! !

!RestMockResourceHttpHandlerAuth methodsFor: 'as yet unclassified' stamp: 'topa 3/5/2009 14:31'!
isAuthorized: anHeaderField

	^ true! !

!RestMockResourceHttpHandlerAuth methodsFor: 'authentication' stamp: 'topa 3/5/2009 11:25'!
needsAuthentication

	^ true! !

TestCase subclass: #RestSocketTestCase
	instanceVariableNames: 'site'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestSocketTestCase class methodsFor: 'accessing' stamp: 'topa 3/3/2009 21:52'!
httpUrl

	^ 'http://www.google.com' asUrl! !

!RestSocketTestCase class methodsFor: 'accessing' stamp: 'topa 3/3/2009 21:52'!
url

	^ 'https://www.verisign.com/favicon.ico' asUrl! !

!RestSocketTestCase methodsFor: 'tests' stamp: 'mig 2/23/2009 16:45'!
testDefaultReturn

	self
		should: ((RestSocket    getDocumentFromUrl: self class httpUrl request: '') isKindOf: RestResponse);
		should: ((RestSocket    getDocumentFromUrl: self class url request: '') isKindOf: RestResponse);
		should: ((RestSocket    putDocumentFromUrl: self class url request: '' content: 'foo') isKindOf: RestResponse);
		should: ((RestSocket   postDocumentFromUrl: self class url request: '' content: 'bar') isKindOf: RestResponse);
		should: ((RestSocket deleteDocumentFromUrl: self class url request: '') isKindOf: RestResponse).! !

TestCase subclass: #RestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

RestTest subclass: #RestHttpServiceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestHttpServiceTest methodsFor: 'running' stamp: 'topa 2/25/2009 13:28'!
setUp
	"avoid upcall"! !

!RestHttpServiceTest methodsFor: 'tests' stamp: 'topa 2/26/2009 19:39'!
testStartAndStop
	
	RestHttpService startOn: self class port.
	(Delay forMilliseconds: 100) wait.
	
	self
		should: (RestHttpService resource isKindOf: RestHttpService);
		should: RestHttpService isRunning.
	
	RestHttpService stop.
	(Delay forMilliseconds: 100) wait.
	
	self
		should: (RestHttpService resource isNil);
		shouldnt: RestHttpService isRunning.! !

RestTest subclass: #RestPerformTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestPerformTest methodsFor: 'running' stamp: 'topa 3/3/2009 22:02'!
setUp

	super setUp.
	RestHttpService resource
		installHandler: RestPerformHttpHandler
		on: '/'! !

!RestPerformTest methodsFor: 'tests' stamp: 'topa 3/3/2009 22:02'!
testPort

	| response |
	response := self get: 'RestHttpService/port'.
	self should: response content = RestHttpService port asString.! !

RestTest subclass: #RestProxyCollectionTest
	instanceVariableNames: 'sut testObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestProxyCollectionTest methodsFor: 'running' stamp: 'mt 3/16/2009 11:22'!
setUp
	"Install a handler for http service. Add a testObject to the database."

	super setUp.
	RestHttpService resource installHandler: RestMockResourceHttpHandler
		on: '/'.
	TestEntity prepare.
	testObject := TestObject all first.
	sut := (RestProxyObject fromServer: self class url
				path: ('tests/{1}' format: {  (testObject id)}))
				repository: (RestProxyRepository fromString: self class url);
				secondLevelTestObjects! !

!RestProxyCollectionTest methodsFor: 'tests' stamp: 'mt 3/5/2009 16:44'!
testAddRestObject

	| newObject |
	newObject := SecondLevelTestObject new userName: 'harry potter'.
	sut add: newObject.
	self
		should: sut size = 2;
		should: sut second userName = newObject userName;
		should: testObject secondLevelTestObjects size = 2;
		should: testObject secondLevelTestObjects second userName = newObject userName.! !

!RestProxyCollectionTest methodsFor: 'tests' stamp: 'mt 3/5/2009 17:42'!
testDeleteRestObject

	sut remove: sut first.
	self
		should: sut isEmpty;
		should: testObject secondLevelTestObjects isEmpty.! !

!RestProxyCollectionTest methodsFor: 'tests' stamp: 'mt 3/5/2009 16:27'!
testGetRestObjects

	| done |	
	self
		should: sut size = 1;
		should: (sut isKindOf: RestProxyCollection).
	done := false.
	sut do: [:each | done := true].
	self
		should: done;
		should: sut first userName = testObject secondLevelTestObjects first userName.! !

!RestProxyCollectionTest methodsFor: 'tests' stamp: 'mig 3/13/2009 15:27'!
testReloadRestObjects

	self should: sut size = 1.
	self should: sut first userName = testObject secondLevelTestObjects first userName.
	testObject secondLevelTestObjects first delete.
	sut reload.
	self should: sut isEmpty.! !

RestTest subclass: #RestProxyObjectFactoryTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestProxyObjectFactoryTest methodsFor: 'running' stamp: 'mig 3/13/2009 16:03'!
setUp
	"Install a handler for http service. Add a testObject to the database."

	super setUp.
	RestHttpService resource installHandler: RestMockResourceHttpHandler
		on: '/'.
	TestEntity prepare.
	sut := RestProxyRepository fromString: self class url! !

!RestProxyObjectFactoryTest methodsFor: 'tests' stamp: 'mt 3/4/2009 13:59'!
testRestObjectFactoryAdd

	| object testObject oldCount |
	oldCount := TestObject all size.
	object := sut 
		addObject: 'tests/'
		with: (TestObject new userName: 'New Test for Factory').
	testObject := TestObject all last.
	self
		should: TestObject all size = (oldCount + 1);
		should: object userName = testObject userName;
		should: object id = testObject id! !

!RestProxyObjectFactoryTest methodsFor: 'tests' stamp: 'mt 3/4/2009 13:59'!
testRestObjectFactoryGet

	| object testObject |
	testObject := TestObject all first.
	object := sut getObject: 'tests/' , testObject id asString.
	self
		should: object userName = testObject userName;
		should: object id = testObject id! !

!RestProxyObjectFactoryTest methodsFor: 'tests' stamp: 'mt 3/4/2009 14:00'!
testRestObjectFactoryGetCollection

	| testObjects collection |
	testObjects := TestObject all.
	collection := sut getCollection: 'tests/'.

	self should: collection size = testObjects size.
	collection do: [:eachSut | 
		self should: (testObjects anySatisfy: [:eachTestObject | 
			eachSut id = eachTestObject id 
			and: [eachSut userName = eachTestObject userName]])]! !

!RestProxyObjectFactoryTest methodsFor: 'tests' stamp: 'mig 3/13/2009 11:19'!
testRestObjectFactorySameCollection

	| collection1 collection2 |
	collection1 := sut getCollection: 'tests/'.
	collection2 := sut getCollection: 'tests/'.

	self should: collection1 == collection2.! !

!RestProxyObjectFactoryTest methodsFor: 'tests' stamp: 'mig 3/13/2009 11:32'!
testRestObjectFactorySameObject

	| object1 object2 |
	object1 := sut getObject: 'tests/', TestObject all first id asString.
	object2 := sut getObject: 'tests/', TestObject all first id asString.

	self should: object1 == object2.! !

!RestProxyObjectFactoryTest methodsFor: 'tests' stamp: 'mig 3/13/2009 12:58'!
testRestObjectFactorySameObjectInHierachy

	| object1 object2 |
	object1 := sut getObject: '/tests/', TestObject all first id asString.
	object2 := object1 secondLevelTestObjects first testObject.

	self should: object1 == object2.! !

RestTest subclass: #RestProxyObjectTest
	instanceVariableNames: 'sut testObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestProxyObjectTest methodsFor: 'running' stamp: 'mt 3/16/2009 12:09'!
setUp
	"Install a handler for http service. Add a testObject to the database."

	super setUp.
	RestHttpService resource installHandler: RestMockResourceHttpHandler
		on: '/'.
	TestEntity prepare.
	testObject := TestObject all first.
	sut := (RestProxyObject fromServer: self class url
				path: '/tests/' , testObject id asString) 
					repository: (RestProxyRepository fromString: self class url).
	sut repository cache at: sut restUri put: sut.! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'topa 3/3/2009 18:04'!
testDeleteRestObject

	| oldCount |
	oldCount := TestObject all size.

	sut delete.

	self should: TestObject all size = (oldCount - 1).
	[(RestProxyObject fromServer: self class url
		path: 'tests/' , testObject id asString)
		title] 
	on: Exception
	do: [^ self].
			
	self fail.! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'mt 3/4/2009 13:55'!
testGetRestObject

	self
		should: sut userName = testObject userName;
		should: sut id = testObject id;
		should: 
			sut secondLevelTestObjects size = testObject secondLevelTestObjects size.! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'cs 3/17/2009 11:40'!
testRestObjectReference

	| cache sut2 sut3 oldUri |
	cache := sut repository cache.
	sut2 := sut secondLevelTestObjects first.
	oldUri := sut2 restUri.
	
	self
		should: sut = sut2 testObject;
		should: (cache includesKey: oldUri).
	
	sut3 := (RestProxyObject fromServer: self class url
				path: '/tests/' , TestObject all second id asString) 
					repository: sut repository.
	cache at: sut3 restUri put: sut3.
	
	self
		should: TestObject all second secondLevelTestObjects isEmpty;
		should: testObject secondLevelTestObjects first testObject = testObject.
		
	sut2 testObject: sut3.

	self
		should: TestObject all second secondLevelTestObjects first testObject = TestObject all second;
		should: testObject secondLevelTestObjects isEmpty;
		should: sut3 = sut2 testObject;
		shouldnt: (cache includesKey: oldUri);
		should: (cache includesKey: sut2 restUri).! !

!RestProxyObjectTest methodsFor: 'tests' stamp: 'mt 3/16/2009 11:35'!
testUpdateRestObject

	| sut2 |
	sut userName: 'New User Name!!'.
	self should: testObject userName = 'New User Name!!'.
	
	sut2 := (RestProxyObject
		fromServer: self class url
		path: 'tests/' , testObject id asString)
		repository: sut repository.
	self should: sut2 userName = 'New User Name!!'! !

RestTest subclass: #RestResourceAuthTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestResourceAuthTest methodsFor: 'tests' stamp: 'topa 3/5/2009 15:52'!
testNeedsAuthentication

	| response |
	RestHttpService resource
		installHandler: RestMockResourceHttpHandlerAuth "has needsAuthentication true"
		on: '/'.
	response := self get: 'tests' request: ''.
	self should: response responseCode = 401.
	response := self get: 'tests' request: self class auth.
	self should: response responseCode = 200.
! !

!RestResourceAuthTest methodsFor: 'tests' stamp: 'topa 3/5/2009 12:52'!
testNeedsNoAuthentication

	| response |
	RestHttpService resource
		installHandler: RestMockResourceHttpHandler  "has needsAuthentication false"
		on: '/'.
	response := self get: 'tests'.
	self should: response responseCode = 200.! !

!RestTest class methodsFor: 'as yet unclassified' stamp: 'topa 3/5/2009 14:15'!
auth

	^ 'Authorization: Basic dGVzdDoxMjM=', String crlf! !

!RestTest class methodsFor: 'as yet unclassified' stamp: 'SR 3/9/2009 10:52'!
authUser2Pass

	^ 'Authorization: Basic ', 
		(Base64MimeConverter mimeEncode: (self login2, ':', self password) readStream) upToEnd, String crlf! !

!RestTest class methodsFor: 'as yet unclassified' stamp: 'topa 3/5/2009 14:48'!
authUserPass

	^ 'Authorization: Basic ', 
		(Base64MimeConverter mimeEncode: (self login, ':', self password) readStream) upToEnd, String crlf! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 3/3/2009 21:53'!
host

	^ 'localhost'! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 3/3/2009 21:53'!
ip

	^ '127.0.0.1'! !

!RestTest class methodsFor: 'testing' stamp: 'mfp 3/6/2009 13:40'!
isAbstract

	^ self == RestTest! !

!RestTest class methodsFor: 'as yet unclassified' stamp: 'topa 3/5/2009 14:47'!
login

	^ 'test.user@example.com'! !

!RestTest class methodsFor: 'as yet unclassified' stamp: 'SR 3/9/2009 10:50'!
login2

	^ 'test.user2@example.com'! !

!RestTest class methodsFor: 'as yet unclassified' stamp: 'topa 3/5/2009 14:47'!
password

	^ 'foobar123'! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 3/3/2009 21:53'!
port

	^ 58082! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 3/5/2009 15:29'!
url
	
	^ 'http://{1}:{2}@{3}:{4}/' format: {self login encodeForHTTP. self password encodeForHTTP. self ip. self port}! !

!RestTest methodsFor: 'helping' stamp: 'mfp 3/6/2009 14:02'!
delete: aPath
	"Send an HTTP request with DELETE to localhost at the port of the (singleton) rest HTTP service."
	
	^ RestSocket
		deleteDocumentFromUrl: (self class url, aPath) asUrl
		request: ''! !

!RestTest methodsFor: 'helping' stamp: 'test 3/6/2009 13:33'!
delete: aPath request: aRequest
	"Send an HTTP request with DELETE to localhost at the port of the (singleton) rest HTTP service."
	
	^ RestSocket
		deleteDocumentFromUrl: ('http://{1}:{2}/{3}' 
			format: {self class url asUrl authority. self class url asUrl port. aPath}) asUrl
		request: aRequest! !

!RestTest methodsFor: 'helping' stamp: 'topa 3/5/2009 15:50'!
get: aPath
	"Send an HTTP request with GET to localhost at the port of the (singleton) rest HTTP service."

	^ RestSocket
		getDocumentFromUrl: (self class url, aPath) asUrl
		request: ''! !

!RestTest methodsFor: 'helping' stamp: 'topa 3/5/2009 15:52'!
get: aPath request: aRequest
	"Send an HTTP request with GET to localhost at the port of the (singleton) rest HTTP service."

	^ RestSocket
		getDocumentFromUrl: ('http://{1}:{2}/{3}' 
			format: {self class url asUrl authority. self class url asUrl port. aPath}) asUrl
		request: aRequest! !

!RestTest methodsFor: 'helping' stamp: 'topa 3/3/2009 21:58'!
jsonDataFrom: someFields
	"Create a string for all fields in the dictionary in JSON."
	
	| stream |
	stream := TextStream with: String new.
	(Dictionary newFrom: someFields) jsonWriteOn: stream.	
	^ stream contents! !

!RestTest methodsFor: 'helping' stamp: 'mfp 3/6/2009 14:03'!
post: aPath content: aContent
	"Send an HTTP request with POST to localhost at the port of the (singleton) rest HTTP service. 
	Append the given fields to the request body."

	^ RestSocket
		postDocumentFromUrl: (self class url, aPath) asUrl
		request: ''
		content: aContent! !

!RestTest methodsFor: 'helping' stamp: 'test 3/6/2009 13:33'!
post: aPath content: aContent request: aRequest
	"Send an HTTP request with POST to localhost at the port of the (singleton) rest HTTP service.
	 Append the given fields to the request body."

	^ RestSocket
		postDocumentFromUrl: ('http://{1}:{2}/{3}' 
			format: {self class url asUrl authority. self class url asUrl port. aPath}) asUrl
		request: aRequest
		content: aContent! !

!RestTest methodsFor: 'helping' stamp: 'mfp 3/6/2009 14:03'!
put: aPath content: aContent
	"Send an HTTP request with PUT to localhost at the port of the (singleton) rest HTTP service. Append the given fields to the request body."
	
	^ RestSocket
		putDocumentFromUrl: (self class url, aPath) asUrl
		request: ''
		content: aContent! !

!RestTest methodsFor: 'helping' stamp: 'test 3/6/2009 13:33'!
put: aPath content: aContent request: aRequest
	"Send an HTTP request with PUT to localhost at the port of the (singleton) rest HTTP service. 
	Append the given fields to the request body."
	
	^ RestSocket
		putDocumentFromUrl: ('http://{1}:{2}/{3}' 
			format: {self class url asUrl authority. self class url asUrl port. aPath}) asUrl
		request: aRequest
		content: aContent! !

!RestTest methodsFor: 'running' stamp: 'topa 3/3/2009 18:37'!
setUp

	super setUp.
	RestHttpService startOn: self class port.
! !

!RestTest methodsFor: 'running' stamp: 'mt 3/12/2009 13:16'!
tearDown

	RestHttpService stop.
	super tearDown.! !
TestEntity initialize!
